#include "SPWF01SA11.h"
//--------------------------------------------
//    
volatile int8_t avg_cnt;
volatile int8_t avg_cnt_temp;
//--------------------------------------------
extern UART_HandleTypeDef huart1;
extern UART_HandleTypeDef huart2;
char str_msg[30]={0};
char str_cmd[30]={0};
char buf_uart2tx[30]={0};
char buf_uart2rx[30]={0};
char buf_msgrx[100]={0};
char buf_cmdrx[100]={0};
uint16_t usart_msg_bit=0;
uint16_t usart_cmd_bit=0;
//--------------------------------------------
void Error(void)
{
	LD2_OFF;
}
//--------------------------------------------
int32_t MovingAverage(int32_t dt)
{
//   
	static int32_t buf_avg[8]={0};
//   
	static int64_t tmp64;
	int32_t dt_ret;
	if(avg_cnt<8)
	{
		buf_avg[avg_cnt]=dt;
		if(avg_cnt==7)
		{
			tmp64=buf_avg[7]+buf_avg[6]+buf_avg[5]+buf_avg[4]+\
							 buf_avg[3]+buf_avg[2]+buf_avg[1]+buf_avg[0];
			dt_ret=tmp64/8;
		}
		avg_cnt++;
	}
	else
	{
		//     ( ) 
		tmp64-=buf_avg[0];
		//   1 
		memcpy((void*)buf_avg,(void*)(buf_avg+1),sizeof(int32_t)*7);
		// 7   
		buf_avg[7]=dt;
		//  
		tmp64+=dt;
		//  
		dt_ret=tmp64/8;
	}
	return dt_ret;
}
//--------------------------------------------
int32_t MovingAverageTemp(int32_t dt)
{
//   
	static int32_t buf_avg[8]={0};
//   
	static int64_t tmp64;
	int32_t dt_ret;
	if(avg_cnt_temp<8)
	{
		buf_avg[avg_cnt_temp]=dt;
		if(avg_cnt_temp==7)
		{
			tmp64=buf_avg[7]+buf_avg[6]+buf_avg[5]+buf_avg[4]+\
							 buf_avg[3]+buf_avg[2]+buf_avg[1]+buf_avg[0];
			dt_ret=tmp64/8;
		}
		avg_cnt_temp++;
	}
	else
	{
		//     ( ) 
		tmp64-=buf_avg[0];
		//   1 
		memcpy((void*)buf_avg,(void*)(buf_avg+1),sizeof(int32_t)*7);
		// 7   
		buf_avg[7]=dt;
		//  
		tmp64+=dt;
		//  
		dt_ret=tmp64/8;
	}
	return dt_ret;
}
//--------------------------------------------
void wifi_wakeup (wifi_bool wakeup)
{
	if(wakeup)
		HAL_GPIO_WritePin(GPIOC,GPIO_PIN_8,GPIO_PIN_SET);
	else
		HAL_GPIO_WritePin(GPIOC,GPIO_PIN_8,GPIO_PIN_RESET);
}
//--------------------------------------------
void wifi_reset (void)
{
	/* === RESET PIN PC12 ===*/
	HAL_GPIO_WritePin(GPIOC,GPIO_PIN_12,GPIO_PIN_RESET);
	HAL_Delay(200);
	HAL_GPIO_WritePin(GPIOC,GPIO_PIN_12,GPIO_PIN_SET);
	HAL_Delay(50);
	HAL_GPIO_DeInit(GPIOC,GPIO_PIN_12);
}
//--------------------------------------------
void WIFI_UART_RxCpltCallback(void)
{
	HAL_UART_Receive_IT(&huart1,(uint8_t*)str_msg,1);
	buf_msgrx[usart_msg_bit++]=str_msg[0];
	if(buf_msgrx[usart_msg_bit-2]==0x0D)
	{
		if(buf_msgrx[usart_msg_bit-1]==0x0A)
		{
			if(usart_msg_bit>3)
			{
				HAL_UART_Transmit_DMA(&huart2,(uint8_t*)buf_msgrx,usart_msg_bit);
				usart_msg_bit=0;
			}
		}
	}
}
//--------------------------------------------
void UART2_UART_RxCpltCallback(void)
{
	HAL_UART_Receive_IT(&huart2,(uint8_t*)str_cmd,1);
	buf_cmdrx[usart_cmd_bit++]=str_cmd[0];
	if(buf_cmdrx[usart_cmd_bit-2]==0x0D)
	{
		if(buf_cmdrx[usart_cmd_bit-1]==0x0A)
		{
			if(usart_cmd_bit>3)
			{
				HAL_UART_Transmit_DMA(&huart2,(uint8_t*)buf_cmdrx,usart_cmd_bit);
				HAL_UART_Transmit(&huart1,(uint8_t*)buf_cmdrx,usart_cmd_bit,0x1000);
				usart_cmd_bit=0;
			}
		}
	}
	
}
//--------------------------------------------
void SPWF01SA11_Ini(void)
{
	wifi_wakeup(WIFI_TRUE);
	wifi_reset();
	HAL_UART_Receive_IT(&huart1,(uint8_t*)str_msg,1);
	HAL_UART_Receive_IT(&huart2,(uint8_t*)str_cmd,1);
	wifi_wakeup(WIFI_FALSE);
}
